//+------------------------------------------------------------------+
//|                                                  PanelDialog.mqh |
//|                        Copyright 2011, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#include <Controls\Dialog.mqh>
#include <Controls\Panel.mqh>
#include <Controls\Edit.mqh>
#include <Controls\Label.mqh>
#include <Controls\SpinEdit.mqh>
//+------------------------------------------------------------------+
//| defines                                                          |
//+------------------------------------------------------------------+
//---   
#define INDENT_LEFT                         (11)      //    (   )
#define INDENT_TOP                          (11)      //   (   )
#define INDENT_RIGHT                        (11)      //   (   )
#define INDENT_BOTTOM                       (11)      //    (   )
#define CONTROLS_GAP_X                      (10)      //   X
#define CONTROLS_GAP_Y                      (10)      //   Y
//---  
#define LABEL_WIDTH                         (50)      //   X
//---  
#define EDIT_WIDTH                          (60)      //   X
#define EDIT_HEIGHT                         (20)      //   Y

//+------------------------------------------------------------------+
//|  CPanelDialog                                               |
//| :                               |
//+------------------------------------------------------------------+
class CPanelDialog : public CAppDialog
  {
private:
   //---  
   CLabel            m_label_red;                     //    ""
   CEdit             m_field_red;                     //    ""
   CLabel            m_label_green;                   //    ""
   CEdit             m_field_green;                   //    ""
   //---  
   double               m_red;                           //  ""
   int               m_green;                         //  ""

public:
                     CPanelDialog(void);
                    ~CPanelDialog(void);
   //--- 
   virtual bool      Create(const long chart,const string name,const int subwin,const int x1,const int y1,const int x2,const int y2);
   //---   
   virtual bool      OnEvent(const int id,const long &lparam,const double &dparam,const string &sparam);
   //--- 
   void              SetRed(const double value);
   double              MyRed();
   int                 MyGreen();
   void              SetGreen(const int value);

protected:
   //---   
   bool              CreateRed(void);
   bool              CreateGreen(void);
   //---    
   
  };
//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
EVENT_MAP_BEGIN(CPanelDialog)
  
EVENT_MAP_END(CAppDialog)
//+------------------------------------------------------------------+
//|                                                       |
//+------------------------------------------------------------------+
CPanelDialog::CPanelDialog(void)
  {
  }
//+------------------------------------------------------------------+
//|                                                        |
//+------------------------------------------------------------------+
CPanelDialog::~CPanelDialog(void)
  {
  }
//+------------------------------------------------------------------+
//|                                                          |
//+------------------------------------------------------------------+
bool CPanelDialog::Create(const long chart,const string name,const int subwin,const int x1,const int y1,const int x2,const int y2)
  {
//---    
   if(!CAppDialog::Create(chart,name,subwin,x1,y1,x2,y2))                           return(false);
//---   
   if(!CreateRed())                                                                 return(false);
   if(!CreateGreen())                                                               return(false);
//---   
   
//--- 
   return(true);
  }

//+------------------------------------------------------------------+
//|    "Red"             |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateRed(void)
  {
//--- 
   int x1=INDENT_LEFT;
   int y1=INDENT_TOP;
   int x2=x1+EDIT_WIDTH;
   int y2=y1+EDIT_HEIGHT;
//---  
   if(!m_label_red.Create(m_chart_id,m_name+"LabelRed",m_subwin,x1,y1+1,x2,y2))     return(false);
   if(!m_label_red.Text("Limit"))                                                     return(false);
   if(!Add(m_label_red))                                                            return(false);
//---  
   x1+=LABEL_WIDTH+CONTROLS_GAP_X;
   x2=x1+EDIT_WIDTH;
//---  
   if(!m_field_red.Create(m_chart_id,m_name+"Red",m_subwin,x1,y1,x2,y2))            return(false);
   if(!m_field_red.Text(DoubleToString(m_red)))                                    return(false);
   if(!m_field_red.ReadOnly(false))                                                  return(false);
   if(!Add(m_field_red))                                                            return(false);
//--- 
   return(true);
  }
//+------------------------------------------------------------------+
//|    "Green"           |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateGreen(void)
  {
//--- 
   int x1=INDENT_LEFT;
   int y1=INDENT_TOP+(EDIT_HEIGHT+CONTROLS_GAP_Y);
   int x2=x1+EDIT_WIDTH;
   int y2=y1+EDIT_HEIGHT;
//---  
   if(!m_label_green.Create(m_chart_id,m_name+"LabelGreen",m_subwin,x1,y1+1,x2,y2)) return(false);
   if(!m_label_green.Text("Period"))                                                 return(false);
   if(!Add(m_label_green))                                                          return(false);
//---  
   x1+=LABEL_WIDTH+CONTROLS_GAP_X;
   x2=x1+EDIT_WIDTH;
//---  
   if(!m_field_green.Create(m_chart_id,m_name+"Green",m_subwin,x1,y1,x2,y2))        return(false);
   if(!m_field_green.Text(IntegerToString(m_green)))                                return(false);
   if(!m_field_green.ReadOnly(false))                                                return(false);
   if(!Add(m_field_green))                                                          return(false);
//--- 
   return(true);
  }

//+------------------------------------------------------------------+
//|   "Red"                                         |
//+------------------------------------------------------------------+
void CPanelDialog::SetRed(const double value)
  {
//--- 
   if(value<0 || value>255) return;
//--- 
   m_red=value;
//--- 
   m_field_red.Text(DoubleToString(value));
//---   
   
  }
  
 //------------------------------------------------------------------
 //     "Red"
 //------------------------------------------------------------------
 double CPanelDialog::MyRed()
 {
    return (StringToDouble(m_field_red.Text()));
 }
//+------------------------------------------------------------------+
//|   "Green"                                       |
//+------------------------------------------------------------------+
void CPanelDialog::SetGreen(const int value)
  {
//--- 
   if(value<0 || value>255) return;
//--- 
   m_green=value;
//--- 
   m_field_green.Text(IntegerToString(value));
  }

//+------------------------------------------------------------------+
//|     "Green"
//+------------------------------------------------------------------+
int CPanelDialog::MyGreen()
{
   return (StringToInteger(m_field_green.Text()));
}
//+------------------------------------------------------------------+
